<template>
  <v-container fluid fill-height>
    <v-layout align-center justify-center>
      <v-flex xs12 sm8 md4>
        <v-card class="elevation-12">
          <v-toolbar dark color="primary">
            <v-toolbar-title>Checking OTP</v-toolbar-title>
          </v-toolbar>
          <v-card-text>
            <v-form>
              <v-text-field
                  :disabled="statusProgress"
                  prepend-icon="lock"
                  v-model="otp"
                  label="OTP"
                  type="password"
                  @keypress="filter(event)"
                  @blur="setResetError"
                  @input="setResetError"
                  :error-messages="error_payload.otp"
              ></v-text-field>
              <v-text-field
                  label="version"
                  :value="version"
                  prepend-icon="info"
                  readonly
              />
            </v-form>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="primary" @click="doVerify" :disabled="statusProgress">Verify OTP</v-btn>
          </v-card-actions>
        </v-card>
      </v-flex>
    </v-layout>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";
import {checkError400} from "../utils/util";

export default {
  name: "CheckOtp",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      otp: null,
      version: process.env.VUE_APP_VERSION,
      statusProgress: false,
      error_payload: {
        otp: []
      }
    }
  },
  methods: {
    async doVerify() {
      if (this.otp == null || this.otp === '') {
        this.$refs.dlgMsg.doOpenMsg('OTP Harus Diisi!. ')
      } else {
        let username = this.$store.getters.getUsernameTmp
        let password = this.$store.getters.getPasswordTmp
        let otp = this.otp
        let res_data = null

        this.statusProgress = true
        await this.$store.dispatch('doLogin', {username, password, otp}).then(resp => {
          res_data = resp.data
          if (res_data.status === 'SUCCESS') {
            window.location = '/dashboard'
          }
        }).catch(err => {
          this.statusProgress = false
          checkError400(err, this.$refs.dlgMsg, this.error_payload)
        })
      }
    },
    setResetError() {
      this.error_payload.otp = [];
    },
    filter(evt) {
      evt = (evt) ? evt : window.event;
      let expect = evt.target.value.toString() + evt.key.toString();

      if (!/^[-+]?[0-9]*\.?[0-9]*$/.test(expect)) {
        evt.preventDefault();
      } else {
        return true;
      }
    }
  },
}
</script>

<style scoped>

</style>